!
! (c) Cray Inc.  All Rights Reserved.  Unpublished Proprietary
! Information.  This unpublished work is protected to trade secret,
! copyright and other laws.  Except as permitted by contract or
! express written permission of Cray Inc., no part of this work or
! its content may be used, reproduced or disclosed in any form.
!
      program example_OpenACC
      use iso_c_binding

      integer  m,n,k,lda,ldb,ldc,iseed(4)
      integer  i,j

      real(kind=8) ,pointer, dimension (:,:) :: a,b,c
      type(C_PTR)::cptr_A,cptr_B, cptr_C
      double precision, allocatable::  c2(:,:)
      double precision  alpha, beta, work,error, error2
      double precision  dlange, MPI_Wtime,flops,gpu_flops,cpu_flops
      double precision  t1, t2, t_acc,t_acc2, t_cpu
      integer           err
      external dlange,MPI_Wtime,dgemm,dgemm_acc,dgemm_cpu
      external libsci_acc_init
!
!     Create random matrices
      call libsci_acc_init()
      print "(a6,a15,a15,a12)", "N", "HYBRID GFlops", "CPU GFlops", &
              "ERROR"
      do i = 512, 8192, 512
         allocate(c2(i,i))
         err = libsci_acc_HostAlloc(cptr_A, INT8(i*i*8))
         err = libsci_acc_HostAlloc(cptr_B, INT8(i*i*8))
         err = libsci_acc_HostAlloc(cptr_C, INT8(i*i*8))
!        Create (a(i,i)

         alpha = 1.0D+0
         beta =  0.7D+0
         iseed(1)=0
         iseed(2)=0
         iseed(3)=0
         iseed(4)=1
         m =i
         n =i
         k =i
         lda =i
         ldb =i
         ldc =i
         call c_f_pointer(cptr_A,a,(/lda,i/))
         call c_f_pointer(cptr_B,b,(/ldb,i/))
         call c_f_pointer(cptr_C,c,(/ldc,i/))
         call dlarnv( 1, iseed, lda*k, a )
         call dlarnv( 1, iseed, ldb*n, b )
         call dlarnv( 1, iseed, ldc*n, c )
         c2(:,:) = c(:,:)
!
!     Call GPU routine
!

     
         t1 = MPI_Wtime()
         call dgemm('n','n',m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
         t2 = MPI_Wtime()
         t_acc = t2-t1

!
         t1 = MPI_Wtime()
         call dgemm_cpu('n','n',m,n,k,alpha,a,lda,b,ldb,beta,c2,ldc)
         t2 = MPI_Wtime()
         t_cpu = t2-t1
!
!     Get the maximum error
!
         c(:,:) = c(:,:)-c2(:,:)
         error = dlange('M',m,n,c,ldc,work)
         flops = dble(m)*dble(n)*dble(k)
         cpu_flops = (2.0*flops)*1.0d-9/(t_acc)
         gpu_flops = (2.0*flops)*1.0d-9/(t_cpu)
         print "(i6,a3,f12.3,f12.3a3,es12.3)", N," ", cpu_flops, &
                gpu_flops, " ",error


         err = libsci_acc_FreeHost(cptr_A)
         if (err > 0) then
            print *,"TESTS FAILED : Free Host =",err
         end if

         err = libsci_acc_FreeHost(cptr_B)
         if (err > 0) then
            print *,"TESTS FAILED : Free Host  =",err
         end if

         err = libsci_acc_FreeHost(cptr_C)
         if (err > 0) then
            print *,"TESTS FAILED : Free Host  =",err
         end if

         deallocate(c2)
      end do
      call libsci_acc_finalize()
      end program

